ConRO.Druid = {};
ConRO.Druid.CheckTalents = function()
end
local ConRO_Druid, ids = ...;

function ConRO:EnableRotationModule(mode)
	mode = mode or 1;
	self.ModuleOnEnable = ConRO.Druid.CheckTalents;
	self.ModuleOnEnable = ConRO.Druid.CheckPvPTalents;
	if mode == 1 then
		self.Description = "Druid [Balance - Caster]";
		self.NextSpell = ConRO.Druid.Balance;
		self.ToggleDamage();
	end;
	if mode == 2 then
		self.Description = "Druid [Feral - Melee]";
		self.NextSpell = ConRO.Druid.Feral;
		self.ToggleDamage();
	end;
	if mode == 3 then
		self.Description = "Druid [Guardian - Tank]";
		self.NextSpell = ConRO.Druid.Guardian;
		self.ToggleDamage();
		self.BlockAoE();
	end;
	if mode == 4 then
		self.Description = "Druid [Restoration - Healer]";
		self.NextSpell = ConRO.Druid.Restoration;
		self.ToggleHealer();
	end;
	self:RegisterEvent('UNIT_SPELLCAST_SUCCEEDED');
	self.lastSpellId = 0;
end

function ConRO:EnableDefenseModule(mode)
	mode = mode or 1;
	self.ModuleOnEnable = ConRO.Druid.CheckTalents;
	self.ModuleOnEnable = ConRO.Druid.CheckPvPTalents;
	if mode == 1 then
		self.NextDef = ConRO.Druid.BalanceDef;
	end;
	if mode == 2 then
		self.NextDef = ConRO.Druid.FeralDef;
	end;
	if mode == 3 then
		self.NextDef = ConRO.Druid.GuardianDef;
	end;
	if mode == 4 then
		self.NextDef = ConRO.Druid.RestorationDef;
	end;
end

function ConRO:UNIT_SPELLCAST_SUCCEEDED(event, unitID, lineID, spellID)
	if unitID == 'player' then
		self.lastSpellId = spellID;
	end
end

	local last_eclipse_phase = "both";
	
function ConRO.Druid.Balance(_, timeShift, currentSpell, gcd, tChosen, pvpChosen)
--Resources	
	local plvl 												= UnitLevel("player");
	local lunar 											= UnitPower('player', Enum.PowerType.LunarPower);

--Abilities
	local tracial											= ConRO:AbilityReady(ids.Racial.Berserking, timeShift);

	local _SootheRDY										= ConRO:AbilityReady(ids.Bal_Ability.Soothe, timeShift); 
	local _CelestialAlignmentRDY, _CelestialAlignment_CD		= ConRO:AbilityReady(ids.Bal_Ability.CelestialAlignment, timeShift);
		local _CelestialAlignmentBUFF							= ConRO:Aura(ids.Bal_Buff.CelestialAlignment, timeShift);
	local _SolarBeamRDY										= ConRO:AbilityReady(ids.Bal_Ability.SolarBeam, timeShift);
	local _MoonfireRDY 											= ConRO:AbilityReady(ids.Bal_Ability.Moonfire, timeShift);
		local _MoonfireDEBUFF									= ConRO:TargetAura(ids.Bal_Debuff.Moonfire, timeShift + 5);
		local _MoonfireDEBUFFM									= ConRO:TargetAura(ids.Bal_Debuff.Moonfire, timeShift + 10);
	local _SunfireRDY										= ConRO:AbilityReady(ids.Bal_Ability.Sunfire, timeShift);
		local _SunfireDEBUFF									= ConRO:TargetAura(ids.Bal_Debuff.Sunfire, timeShift + 3);
		local _SunfireDEBUFFM									= ConRO:TargetAura(ids.Bal_Debuff.Sunfire, timeShift + 8);
	local _WrathRDY											= ConRO:AbilityReady(ids.Bal_Ability.Wrath, timeShift);
		local _EclipseLunarBUFF, _, _EclipseLunarDUR			= ConRO:Aura(ids.Bal_Buff.EclipseLunar, timeShift);
	local _StarfireRDY										= ConRO:AbilityReady(ids.Bal_Ability.Starfire, timeShift);
		local _EclipseSolarBUFF, _, _EclipseSolarDUR			= ConRO:Aura(ids.Bal_Buff.EclipseSolar, timeShift);
	local _StarsurgeRDY										= ConRO:AbilityReady(ids.Bal_Ability.Starsurge, timeShift);
		local _StarlordBUFF, _StarlordCOUNT						= ConRO:Aura(ids.Bal_Buff.Starlord, timeShift);
	local _StarfallRDY										= ConRO:AbilityReady(ids.Bal_Ability.Starfall, timeShift);
		local _StarfallBUFF, _, _StarfallDUR					= ConRO:Aura(ids.Bal_Buff.Starfall, timeShift);
	local _MoonkinFormRDY									= ConRO:AbilityReady(ids.Bal_Ability.MoonkinForm, timeShift);
		local _MoonkinFormBUFF									= ConRO:Form(ids.Bal_Form.MoonkinForm);
		local _OwlkinFrenzyBUFF									= ConRO:Aura(ids.Bal_Buff.OwlkinFrenzy, timeShift);		
		
	local _StellarFlareRDY									= ConRO:AbilityReady(ids.Bal_Talent.StellarFlare, timeShift);	
		local _StellarFlareDEBUFF 								= ConRO:TargetAura(ids.Bal_Debuff.StellarFlare, timeShift + 7);	
	local _WarriorofEluneRDY								= ConRO:AbilityReady(ids.Bal_Talent.WarriorofElune, timeShift);
		local _WarriorofEluneBUFF 								= ConRO:Form(ids.Bal_Form.WarriorofElune);
	local _FuryofEluneRDY									= ConRO:AbilityReady(ids.Bal_Talent.FuryofElune, timeShift);
	local _ForceofNatureRDY									= ConRO:AbilityReady(ids.Bal_Talent.ForceofNature, timeShift);
	local _IncarnationChosenofEluneRDY, _IncarnationChosenofElune_CD	= ConRO:AbilityReady(ids.Bal_Talent.IncarnationChosenofElune, timeShift);
		local _IncarnationChosenofEluneBUFF						= ConRO:Aura(ids.Bal_Buff.IncarnationChosenofElune, timeShift);
	local _NewMoonRDY  										= ConRO:AbilityReady(ids.Bal_Talent.NewMoon, timeShift);
		local _NewMoonCHARGES									= ConRO:SpellCharges(ids.Bal_Talent.NewMoon);

	local _AdaptiveSwarm_RDY								= ConRO:AbilityReady(ids.Covenant_Ability.AdaptiveSwarm, timeShift);
		local _AdaptiveSwarm_DEBUFF								= ConRO:TargetAura(ids.Covenant_Debuff.AdaptiveSwarm, timeShift);
	local _ConvoketheSpirits_RDY							= ConRO:AbilityReady(ids.Covenant_Ability.ConvoketheSpirits, timeShift);
	local _KindredSpirits_RDY								= ConRO:AbilityReady(ids.Covenant_Ability.KindredSpirits, timeShift);
		local _EmpowerBond_RDY								= ConRO:AbilityReady(ids.Covenant_Ability.EmpowerBond, timeShift);
		local _KindredEmpowerment_BUFF							= ConRO:Aura(ids.Covenant_Buff.KindredEmpowerment, timeShift);
		local _KindredSpirits_BUFF								= ConRO:Aura(ids.Covenant_Buff.KindredSpirits, timeShift);
		local _LoneEmpowerment_RDY								= ConRO:AbilityReady(ids.Covenant_Ability.LoneEmpowerment, timeShift);
		local _LoneEmpowerment_BUFF								= ConRO:Aura(ids.Covenant_Buff.LoneEmpowerment, timeShift);
		local _LoneSpirit_BUFF									= ConRO:Aura(ids.Covenant_Buff.LoneSpirit, timeShift);
	local _RavenousFrenzy_RDY								= ConRO:AbilityReady(ids.Covenant_Ability.RavenousFrenzy, timeShift);
	
--Conditions
	local incombat 											= UnitAffectingCombat('player');
	local moving 											= ConRO:PlayerSpeed();
	local targets											= ConRO:Targets(ids.Bal_Ability.Wrath);
	
		if currentSpell == ids.Bal_Talent.FullMoon then
			lunar = lunar + 40;
			_NewMoonCHARGES = _NewMoonCHARGES - 1;
		elseif currentSpell == ids.Bal_Talent.NewMoon then
			lunar = lunar + 10;
			_NewMoonCHARGES = _NewMoonCHARGES - 1;
		elseif currentSpell == ids.Bal_Talent.HalfMoon then
			lunar = lunar + 20;
			_NewMoonCHARGES = _NewMoonCHARGES - 1;
		elseif currentSpell == ids.Bal_Ability.Wrath then
			lunar = lunar + 6;
		elseif currentSpell == ids.Bal_Ability.Starfire then
			lunar = lunar + 8;
		end
	
	local newMoon_phase = ids.Bal_Talent.FullMoon;
		if ConRO:FindSpell(ids.Bal_Talent.NewMoon) then
			newMoon_phase = ids.Bal_Talent.NewMoon;
		elseif ConRO:FindSpell(ids.Bal_Talent.HalfMoon) then
			newMoon_phase = ids.Bal_Talent.HalfMoon;
		end
	
		if _EclipseLunarBUFF and _EclipseSolarBUFF then
			last_eclipse_phase = "both";
		else
			if _EclipseLunarBUFF and not _EclipseSolarBUFF then
				last_eclipse_phase = "lunar";
			end
			if _EclipseSolarBUFF and not _EclipseLunarBUFF then
				last_eclipse_phase = "solar";
			end
		end
	
--Indicators
	ConRO:AbilityInterrupt(ids.Bal_Ability.SolarBeam, _SolarBeamRDY and ConRO:Interrupt());
	ConRO:AbilityPurge(ids.Bal_Ability.Soothe, _SootheRDY and ConRO:Purgable());
	
	ConRO:AbilityBurst(ids.Bal_Talent.IncarnationChosenofElune, _IncarnationChosenofEluneRDY and _MoonfireDEBUFF and _SunfireDEBUFF and (not tChosen[ids.Bal_Talent.StellarFlare] or (tChosen[ids.Bal_Talent.StellarFlare] and _StellarFlareDEBUFF)) and (_EclipseSolarBUFF or _EclipseLunarBUFF) and ConRO_BurstButton:IsVisible());
	ConRO:AbilityBurst(ids.Bal_Ability.CelestialAlignment, _CelestialAlignmentRDY and _MoonfireDEBUFF and _SunfireDEBUFF and (not tChosen[ids.Bal_Talent.StellarFlare] or (tChosen[ids.Bal_Talent.StellarFlare] and _StellarFlareDEBUFF)) and (_EclipseSolarBUFF or _EclipseLunarBUFF) and ConRO_BurstButton:IsVisible() and not tChosen[ids.Bal_Talent.IncarnationChosenofElune]);
	ConRO:AbilityBurst(ids.Bal_Ability.Starfall, _StarfallRDY and (targets >= 3 or (targets >= 2 and (not tChosen[ids.Bal_Talent.Starlord] or (tChosen[ids.Bal_Talent.Starlord] and tChosen[ids.Bal_Talent.StellarDrift])))));
	ConRO:AbilityBurst(ids.Covenant_Ability.ConvoketheSpirits, _ConvoketheSpirits_RDY and (_EclipseSolarBUFF or _EclipseLunarBUFF) and ConRO_BurstButton:IsVisible());
	ConRO:AbilityBurst(ids.Covenant_Ability.RavenousFrenzy, _RavenousFrenzy_RDY and (_EclipseSolarBUFF or _EclipseLunarBUFF) and ConRO_BurstButton:IsVisible());
	
--Rotations	
	if _MoonkinFormRDY and not _MoonkinFormBUFF then
		return ids.Bal_Ability.MoonkinForm;
	end

	if _KindredSpirits_RDY and not _LoneSpirit_BUFF and not _KindredSpirits_BUFF then
		return ids.Covenant_Ability.KindredSpirits;
	end
		
	if not incombat then
		if _WrathRDY and ConRO_AoEButton:IsVisible() then
			return ids.Bal_Ability.Wrath;
		end
		
		if _StarfireRDY and ConRO_SingleButton:IsVisible() then
			return ids.Bal_Ability.Starfire;
		end
	elseif moving then
		if _MoonfireRDY and not _MoonfireDEBUFFM then
			return ids.Bal_Ability.Moonfire;
		elseif _SunfireRDY and not _SunfireDEBUFFM	then
			return ids.Bal_Ability.Sunfire;
		end
		
		if _StarfireRDY and (_WarriorofEluneBUFF or _OwlkinFrenzyBUFF) then
			return ids.Bal_Ability.Starfire;
		end
	else
		if _StarsurgeRDY and lunar >= 30 and (_EclipseLunarBUFF or _EclipseSolarBUFF) and tChosen[ids.Bal_Talent.Starlord] and _StarlordBUFF and _StarlordCOUNT < 3 then
			return ids.Bal_Ability.Starsurge;
		end

		if (tChosen[ids.Bal_Talent.IncarnationChosenofElune] and not _IncarnationChosenofEluneRDY) or (not tChosen[ids.Bal_Talent.IncarnationChosenofElune] and not _CelestialAlignmentRDY) or ConRO_BurstButton:IsVisible() then
			if _StarfallRDY and not _StarfallBUFF and lunar >= 50 and ConRO_AoEButton:IsVisible() then
				return ids.Bal_Ability.Starfall;
			end
		end

		if _MoonfireRDY and not _MoonfireDEBUFF then
			return ids.Bal_Ability.Moonfire;
		elseif _StellarFlareRDY and not _StellarFlareDEBUFF and currentSpell ~= ids.Bal_Talent.StellarFlare then
			return ids.Bal_Talent.StellarFlare;
		elseif _SunfireRDY and not _SunfireDEBUFF then
			return ids.Bal_Ability.Sunfire;
		end
		
		if _AdaptiveSwarm_RDY and not _AdaptiveSwarm_DEBUFF then
			return ids.Covenant_Ability.AdaptiveSwarm;
		end		

		if not _EclipseSolarBUFF and not _EclipseLunarBUFF then
			if last_eclipse_phase == "both" then
				if ConRO_AoEButton:IsVisible() then
					if _WrathRDY then
						return ids.Bal_Ability.Wrath;
					end
				else
					if _StarfireRDY then
						return ids.Bal_Ability.Starfire;
					end
				end
			elseif last_eclipse_phase == "solar" then
				if _WrathRDY then
					return ids.Bal_Ability.Wrath;
				end
			elseif last_eclipse_phase == "lunar" then
				if _StarfireRDY then
					return ids.Bal_Ability.Starfire;
				end
			end
		end
		
		if tChosen[ids.Bal_Talent.IncarnationChosenofElune] then
			if _IncarnationChosenofEluneRDY and not _IncarnationChosenofEluneBUFF and lunar >= 90 and ConRO_FullButton:IsVisible() then
				return ids.Bal_Talent.IncarnationChosenofElune;
			end
		else
			if _CelestialAlignmentRDY and not _CelestialAlignmentBUFF and lunar >= 90 and ConRO_FullButton:IsVisible() then
				return ids.Bal_Ability.CelestialAlignment;
			end
		end

		if (tChosen[ids.Bal_Talent.IncarnationChosenofElune] and not _IncarnationChosenofEluneRDY) or (not tChosen[ids.Bal_Talent.IncarnationChosenofElune] and not _CelestialAlignmentRDY) or ConRO_BurstButton:IsVisible() then
			if _StarsurgeRDY and (_EclipseLunarDUR >= 9 or _EclipseSolarDUR >= 9 or lunar >= 90) and (not tChosen[ids.Bal_Talent.Starlord] or (tChosen[ids.Bal_Talent.Starlord] and not _StarlordBUFF)) then
				if ConRO_SingleButton:IsVisible() then
					return ids.Bal_Ability.Starsurge;
				elseif ConRO_AoEButton:IsVisible() and (_StarfallDUR >= 3 or lunar >= 80) then
					return ids.Bal_Ability.Starsurge;
				end
			end		
		end

		if _ConvoketheSpirits_RDY and ConRO_FullButton:IsVisible() then
			return ids.Covenant_Ability.ConvoketheSpirits;
		end			

		if _EmpowerBond_RDY and _KindredSpirits_BUFF then
			return ids.Covenant_Ability.EmpowerBond;
		end

		if _LoneEmpowerment_RDY and _LoneSpirit_BUFF then
			return ids.Covenant_Ability.LoneEmpowerment;
		end
		
		if _RavenousFrenzy_RDY and ConRO_FullButton:IsVisible() then
			return ids.Covenant_Ability.RavenousFrenzy;
		end		

		if _FuryofEluneRDY and lunar <= 60 and (((_CelestialAlignmentBUFF or _CelestialAlignment_CD >= 50) and not tChosen[ids.Bal_Talent.IncarnationChosenofElune]) or ((_IncarnationChosenofEluneBUFF or _IncarnationChosenofElune_CD >= 40) and tChosen[ids.Bal_Talent.IncarnationChosenofElune])) then
			return ids.Bal_Talent.FuryofElune;
		end		
		
		if _ForceofNatureRDY and lunar <= 80 then
			return ids.Bal_Talent.ForceofNature;
		end
		
		if _WarriorofEluneRDY and not _WarriorofEluneBUFF then
			return ids.Bal_Talent.WarriorofElune;
		end

		if _NewMoonRDY and _NewMoonCHARGES >= 1 and (_EclipseLunarBUFF or _EclipseSolarBUFF) then
			return newMoon_phase;
		end

		if _EclipseSolarBUFF and _EclipseLunarBUFF then
			if ConRO_AoEButton:IsVisible() then
				if _StarfireRDY then
					return ids.Bal_Ability.Starfire;
				end
			else
				if _WrathRDY then
					return ids.Bal_Ability.Wrath;
				end
			end
		end
		
		if _WrathRDY and _EclipseSolarBUFF then
			return ids.Bal_Ability.Wrath;
		end
		
		if _StarfireRDY and _EclipseLunarBUFF then
			return ids.Bal_Ability.Starfire;
		end
	end
end

function ConRO.Druid.BalanceDef(_, timeShift, currentSpell, gcd, tChosen, pvpChosen)
--Abilities	
	local bark 												= ConRO:AbilityReady(ids.Bal_Ability.Barkskin, timeShift);
	
	local renewal 											= ConRO:AbilityReady(ids.Bal_Talent.Renewal, timeShift);

	local _Fleshcraft_RDY									= ConRO:AbilityReady(ids.Covenant_Ability.Fleshcraft, timeShift);
	
--Conditions	
	local playerPh 											= ConRO:PercentHealth('player');

--Rotations	
	if renewal and playerPh <= 60 then
		return ids.Bal_Talent.Renewal;
	end

	if _Fleshcraft_RDY then
		return ids.Covenant_Ability.Fleshcraft;
	end
	
	if bark then
		return ids.Bal_Ability.Barkskin;
	end
	
	return nil;
end

function ConRO.Druid.Feral(_, timeShift, currentSpell, gcd, tChosen, pvpChosen)
--Resources
	local combo 											= UnitPower('player', Enum.PowerType.ComboPoints);
	local energy 											= UnitPower('player', Enum.PowerType.Energy);
	local energyMax 										= UnitPowerMax('player', Enum.PowerType.Energy);

--Abilities	
	local soothe											= ConRO:AbilityReady(ids.Feral_Ability.Soothe, timeShift); 
	local prowl 											= ConRO:AbilityReady(ids.Feral_Ability.Prowl, timeShift);
		local pr 												= ConRO:Form(ids.Feral_Form.Prowl);
	local shred												= ConRO:AbilityReady(ids.Feral_Ability.Shred, timeShift);
	local mang												= ConRO:AbilityReady(ids.Feral_Ability.Mangle, timeShift);
	local fbite												= ConRO:AbilityReady(ids.Feral_Ability.FerociousBite, timeShift);
	local catform 											= ConRO:AbilityReady(ids.Feral_Ability.CatForm, timeShift);
		local bf												= ConRO:Form(ids.Feral_Form.BearForm);
		local cf												= ConRO:Form(ids.Feral_Form.CatForm);
	local regrow 											= ConRO:AbilityReady(ids.Feral_Ability.Regrowth, timeShift);
	
	local tfury 											= ConRO:AbilityReady(ids.Feral_Ability.TigersFury, timeShift + 0.5);
		local tfBuff											= ConRO:Aura(ids.Feral_Buff.TigersFury, timeShift);
	local berserk											= ConRO:AbilityReady(ids.Feral_Ability.Berserk, timeShift);
		local berBuff											= ConRO:Aura(ids.Feral_Buff.Berserk, timeShift);
	local sbash 											= ConRO:AbilityReady(ids.Feral_Ability.SkullBash, timeShift);
	local rake												= ConRO:AbilityReady(ids.Feral_Ability.Rake, timeShift);
		local rakeDebuff 										= ConRO:TargetAura(ids.Feral_Debuff.Rake, timeShift + 4);
		local rakeStun 											= ConRO:TargetAura(ids.Feral_Debuff.RakeStun, timeShift);
	local rip												= ConRO:AbilityReady(ids.Feral_Ability.Rip, timeShift);
		local ripDebuff, _, ripDur 								= ConRO:TargetAura(ids.Feral_Debuff.Rip, timeShift);
	local mfire												= ConRO:AbilityReady(ids.Feral_Talent.Moonfire_Cat, timeShift);
		local mfDebuff											= ConRO:TargetAura(ids.Feral_Debuff.Moonfire, timeShift + 4);
	local thrash											= ConRO:AbilityReady(ids.Feral_Ability.Thrash, timeShift);
		local thrDebuff 										= ConRO:TargetAura(ids.Feral_Debuff.Thrash_Cat, timeShift + 2);
		local thrBCD 											= ConRO:Cooldown(ids.Feral_Ability.Thrash_Bear, timeShift);
		local thrBDebuff, thrBCount 							= ConRO:TargetAura(ids.Feral_Debuff.Thrash_Bear, timeShift);
	local swipe												= ConRO:AbilityReady(ids.Feral_Ability.Swipe, timeShift);
	local swipeB											= ConRO:AbilityReady(ids.Feral_Ability.Swipe_Bear, timeShift);
	local maim												= ConRO:AbilityReady(ids.Feral_Ability.Maim, timeShift);

		local psBuff											= ConRO:Aura(ids.Feral_Buff.PredatorySwiftness, timeShift);
		local ccBuff 											= ConRO:Aura(ids.Feral_Buff.Clearcasting, timeShift);
		
	local kotj												= ConRO:AbilityReady(ids.Feral_Talent.IncarnationKingoftheJungle, timeShift);
		local kotjBuff 											= ConRO:Aura(ids.Feral_Buff.IncarnationKingoftheJungle, timeShift);
	local bslash											= ConRO:AbilityReady(ids.Feral_Talent.BrutalSlash, timeShift);
		local bsCharges, bsMaxCharges, bsCCD					= ConRO:SpellCharges(ids.Feral_Talent.BrutalSlash);
	local ffrenzy			 								= ConRO:AbilityReady(ids.Feral_Talent.FeralFrenzy, timeShift);
	local sroar				 								= ConRO:AbilityReady(ids.Feral_Talent.SavageRoar, timeShift);
		local srBuff, _, srDur									= ConRO:Aura(ids.Feral_Buff.SavageRoar, timeShift);
	local wcharge 											= ConRO:AbilityReady(ids.Feral_Talent.WildCharge, timeShift);
	local pwrath 											= ConRO:AbilityReady(ids.Feral_Talent.PrimalWrath, timeShift);

	local _AdaptiveSwarm_RDY								= ConRO:AbilityReady(ids.Covenant_Ability.AdaptiveSwarm, timeShift);
		local _AdaptiveSwarm_DEBUFF								= ConRO:TargetAura(ids.Covenant_Debuff.AdaptiveSwarm, timeShift);
	local _ConvoketheSpirits_RDY							= ConRO:AbilityReady(ids.Covenant_Ability.ConvoketheSpirits, timeShift);
	local _KindredSpirits_RDY								= ConRO:AbilityReady(ids.Covenant_Ability.KindredSpirits, timeShift);
		local _EmpowerBond_RDY								= ConRO:AbilityReady(ids.Covenant_Ability.EmpowerBond, timeShift);
		local _KindredEmpowerment_BUFF							= ConRO:Aura(ids.Covenant_Buff.KindredEmpowerment, timeShift);
		local _KindredSpirits_BUFF								= ConRO:Aura(ids.Covenant_Buff.KindredSpirits, timeShift);
		local _LoneEmpowerment_RDY								= ConRO:AbilityReady(ids.Covenant_Ability.LoneEmpowerment, timeShift);
		local _LoneEmpowerment_BUFF								= ConRO:Aura(ids.Covenant_Buff.LoneEmpowerment, timeShift);
		local _LoneSpirit_BUFF									= ConRO:Aura(ids.Covenant_Buff.LoneSpirit, timeShift);	
	local _RavenousFrenzy_RDY								= ConRO:AbilityReady(ids.Covenant_Ability.RavenousFrenzy, timeShift);
	
--Conditions
	local inMelee 											= ConRO:IsSpellInRange(GetSpellInfo(ids.Feral_Ability.Rake), 'target');	
	local incombat 											= UnitAffectingCombat('player');
	local targetPh 											= ConRO:PercentHealth('target');
	local tarInMelee										= ConRO:Targets(ids.Feral_Ability.Rake);
	
--Indicators		
	ConRO:AbilityInterrupt(ids.Feral_Ability.SkullBash, sbash and ConRO:Interrupt());
	ConRO:AbilityPurge(ids.Feral_Ability.Soothe, soothe and ConRO:Purgable());
	
	ConRO:AbilityBurst(ids.Feral_Ability.Berserk, berserk and ConRO_BurstButton:IsVisible() and not tChosen[ids.Feral_Talent.IncarnationKingoftheJungle]);
	ConRO:AbilityBurst(ids.Feral_Talent.IncarnationKingoftheJungle, kotj and ConRO_BurstButton:IsVisible());
	ConRO:AbilityBurst(ids.Covenant_Ability.ConvoketheSpirits, _ConvoketheSpirits_RDY and ConRO_BurstButton:IsVisible());
	ConRO:AbilityBurst(ids.Covenant_Ability.RavenousFrenzy, _RavenousFrenzy_RDY and ConRO_BurstButton:IsVisible());
	
--Rotations	
	if _KindredSpirits_RDY and not _LoneSpirit_BUFF and not _KindredSpirits_BUFF then
		return ids.Covenant_Ability.KindredSpirits;
	end
	
	if bf then
		if not inMelee and wcharge then
			return ids.Feral_Talent.WildCharge_Bear;
		end

		if thrash and thrBCD <= 0 and thrBCount < 3 then
			return ids.Feral_Ability.Thrash_Bear;
		end

		if mang then
			return ids.Feral_Ability.Mangle;
		end
		
		if thrash and thrBCD <= 0 then
			return ids.Feral_Ability.Thrash_Bear;
		end
		
		if swipe then
			return ids.Feral_Ability.Swipe_Bear;
		end
	
		return;
	end
	
	if not incombat then 
		if catform and not cf then
			return ids.Feral_Ability.CatForm;
		end
		
		if prowl and not pr then
			return ids.Feral_Ability.Prowl;
		end

		if wcharge and not inMelee then
			return ids.Feral_Talent.WildCharge_Cat;
		end
		
		if rake and not rakeDebuff then
			return ids.Feral_Ability.Rake;
		end		
	
	elseif (ConRO_AutoButton:IsVisible() and tarInMelee >= 4) or ConRO_AoEButton:IsVisible() then
		if catform and not cf then
			return ids.Feral_Ability.CatForm;
		end

		if _RavenousFrenzy_RDY and (berBuff or kotjBuff) and ConRO_FullButton:IsVisible() then
			return ids.Covenant_Ability.RavenousFrenzy;
		end	
		
		if tfury and not tfBuff and energy <= energyMax - 50 then
			return ids.Feral_Ability.TigersFury;
		end

		if _EmpowerBond_RDY and tfBuff and _KindredSpirits_BUFF then
			return ids.Covenant_Ability.EmpowerBond;
		end

		if _LoneEmpowerment_RDY and tfBuff and _LoneSpirit_BUFF then
			return ids.Covenant_Ability.LoneEmpowerment;
		end
		
		if ffrenzy and combo <= 0 then
			return ids.Feral_Talent.FeralFrenzy;
		end
		
		if berserk and ConRO_FullButton:IsVisible() and not tChosen[ids.Feral_Talent.IncarnationKingoftheJungle] then
			return ids.Feral_Ability.Berserk;
		end

		if kotj and ConRO_FullButton:IsVisible() then
			return ids.Feral_Talent.IncarnationKingoftheJungle;
		end

		if _ConvoketheSpirits_RDY and combo <= 2 and energy <= 30 and ConRO_FullButton:IsVisible() then
			return ids.Covenant_Ability.ConvoketheSpirits;
		end	
		
		if bslash and (bsCharges == bsMaxCharges or (bsCharges == bsMaxCharges - 1 and bsCCD <= 1.5)) then
			return ids.Feral_Talent.BrutalSlash;
		end
		
		if pwrath and combo == 5 then
			return ids.Feral_Talent.PrimalWrath;
		end

		if thrash and not thrDebuff then
			return ids.Feral_Ability.Thrash_Cat;
		end
		
		if rake and not rakeDebuff then
			return ids.Feral_Ability.Rake;
		end
		
		if sroar and (not srBuff or srDur <= 10) and combo == 5 then
			return ids.Feral_Talent.SavageRoar;
		end
		
		if rip and not ripDebuff and combo == 5 then
			return ids.Feral_Ability.Rip;
		end

		if _AdaptiveSwarm_RDY and not _AdaptiveSwarm_DEBUFF and rakeDebuff and thrDebuff then
			return ids.Covenant_Ability.AdaptiveSwarm;
		end	
		
		if fbite and combo >= 5 and ripDebuff then
			return ids.Feral_Ability.FerociousBite;
		end
			
		if bslash and thrDebuff and bsCharges >= 1 and combo <= 4 then
			return ids.Feral_Talent.BrutalSlash;
		end

		if swipe and rakeDebuff and not tChosen[ids.Feral_Talent.BrutalSlash] and combo <= 4 then
			return ids.Feral_Ability.Swipe_Cat;
		end
	else
		if catform and not cf then
			return ids.Feral_Ability.CatForm;
		end
		
-- Figure out Bloodtalons		
		if _RavenousFrenzy_RDY and (berBuff or kotjBuff) and ConRO_FullButton:IsVisible() then
			return ids.Covenant_Ability.RavenousFrenzy;
		end	
		
		if ffrenzy and combo <= 0 then
			return ids.Feral_Talent.FeralFrenzy;
		end
		
		if tfury and not tfBuff and energy <= energyMax - 50 then
			return ids.Feral_Ability.TigersFury;
		end

		if _EmpowerBond_RDY and tfBuff and _KindredSpirits_BUFF then
			return ids.Covenant_Ability.EmpowerBond;
		end

		if _LoneEmpowerment_RDY and tfBuff and _LoneSpirit_BUFF then
			return ids.Covenant_Ability.LoneEmpowerment;
		end
		
		if berserk and ConRO_FullButton:IsVisible() and not tChosen[ids.Feral_Talent.IncarnationKingoftheJungle] then
			return ids.Feral_Ability.Berserk;
		end

		if kotj and ConRO_FullButton:IsVisible() then
			return ids.Feral_Talent.IncarnationKingoftheJungle;
		end

		if _ConvoketheSpirits_RDY and combo <= 2 and energy <= 30 and ConRO_FullButton:IsVisible() then
			return ids.Covenant_Ability.ConvoketheSpirits;
		end
		
		if pwrath and combo == 5 and tarInMelee >= 3 then
			return ids.Feral_Talent.PrimalWrath;
		end		

		if bslash and (bsCharges == bsMaxCharges or (bsCharges == bsMaxCharges - 1 and bsCCD <= 1.5)) and tarInMelee >= 2 then
			return ids.Feral_Talent.BrutalSlash;
		end	

		if rip and not ripDebuff and combo >= 5 then
			return ids.Feral_Ability.Rip;
		end

		if tChosen[ids.Feral_Talent.Sabertooth] then
			if fbite and ripDur <= 9 and combo >= 5 then
				return ids.Feral_Ability.FerociousBite;
			end
		else
			if rip and ripDur <= 7 and combo >= 5 then
				return ids.Feral_Ability.Rip;
			end
		end
		
		if rake and not rakeDebuff then
			return ids.Feral_Ability.Rake;
		end		
	
		if sroar and (not srBuff or srDur <= 9) and combo >= 5 then
			return ids.Feral_Talent.SavageRoar;
		end		

		if _AdaptiveSwarm_RDY and not _AdaptiveSwarm_DEBUFF and rakeDebuff and ripDebuff then
			return ids.Covenant_Ability.AdaptiveSwarm;
		end	
		
		if fbite and apBuff then
			return ids.Feral_Ability.FerociousBite;
		end
		
		if fbite and combo >= 5 and (not IsPlayerSpell(ids.Feral_Ability.Rip) or (IsPlayerSpell(ids.Feral_Ability.Rip) and ripDur >= 10)) and (not tChosen[ids.Feral_Talent.SavageRoar] or (tChosen[ids.Feral_Talent.SavageRoar] and srDur >= 10)) then
			return ids.Feral_Ability.FerociousBite;
		end		

		if mfire and not mfDebuff and tChosen[ids.Feral_Talent.LunarInspiration] then
			return ids.Feral_Talent.Moonfire_Cat;
		end
		
		if thrash and not thrDebuff and tarInMelee >= 2 then
			return ids.Feral_Ability.Thrash_Cat;
		end
		
		if swipe and rakeDebuff and not tChosen[ids.Feral_Talent.BrutalSlash] and combo <= 4 and tarInMelee >= 3 then
			return ids.Feral_Ability.Swipe_Cat;
		end
		
		if bslash and combo <= 4 and ((ConRO_AutoButton:IsVisible() and not ccBuff) or ConRO_AoEButton:IsVisible()) then
			return ids.Feral_Talent.BrutalSlash;
		end
		
		if shred and combo <= 4 then
			return ids.Feral_Ability.Shred;
		end
	end
return nil;
end

function ConRO.Druid.FeralDef(_, timeShift, currentSpell, gcd, tChosen, pvpChosen)
--Abilities
	local surv 												= ConRO:AbilityReady(ids.Feral_Ability.SurvivalInstincts, timeShift);
	local _Barkskin_RDY										= ConRO:AbilityReady(ids.Feral_Ability.Barkskin, timeShift);
	
	local renewal 											= ConRO:AbilityReady(ids.Feral_Talent.Renewal, timeShift);

	local _Fleshcraft_RDY									= ConRO:AbilityReady(ids.Covenant_Ability.Fleshcraft, timeShift);
	
--Conditions	
	local playerPh 											= ConRO:PercentHealth('player');

--Rotations	
	if renewal and playerPh <= 60 then
		return ids.Feral_Talent.Renewal;
	end

	if _Fleshcraft_RDY then
		return ids.Covenant_Ability.Fleshcraft;
	end
	
	if _Barkskin_RDY then
		return ids.Feral_Ability.Barkskin;
	end
	
	if surv then
		return ids.Feral_Ability.SurvivalInstincts;
	end
	
	return nil;
end

function ConRO.Druid.Guardian(_, timeShift, currentSpell, gcd, tChosen, pvpChosen)
--Resources
	local rage 												= UnitPower('player', Enum.PowerType.Rage);
	local rageMax 											= UnitPowerMax('player', Enum.PowerType.Rage);

--Abilities	
	local soothe											= ConRO:AbilityReady(ids.Guard_Ability.Soothe, timeShift); 
	local bearform 											= ConRO:AbilityReady(ids.Guard_Ability.BearForm, timeShift);
		local bf 												= ConRO:Form(ids.Guard_Form.BearForm);
	local growl 											= ConRO:AbilityReady(ids.Guard_Ability.Growl, timeShift);
	local mfire 											= ConRO:AbilityReady(ids.Guard_Ability.Moonfire, timeShift);
		local ggBuff 											= ConRO:Aura(ids.Guard_Buff.GalacticGuardian, timeShift);
		local mfDebuff 											= ConRO:TargetAura(ids.Guard_Debuff.Moonfire, timeShift);
	local mang 												= ConRO:AbilityReady(ids.Guard_Ability.Mangle, timeShift);
	local thr 												= ConRO:AbilityReady(ids.Guard_Ability.Thrash, timeShift);
		local thrCD 											= ConRO:Cooldown(ids.Guard_Ability.Thrash_Bear, timeShift);
		local thrDebuff, thrCount 								= ConRO:TargetAura(ids.Guard_Debuff.Thrash, timeShift);
	local swipe 											= ConRO:AbilityReady(ids.Guard_Ability.Swipe, timeShift);
	local sbash 											= ConRO:AbilityReady(ids.Guard_Ability.SkullBash, timeShift);
	local maul												= ConRO:AbilityReady(ids.Guard_Ability.Maul, timeShift);
	
	local wildG 											= ConRO:AbilityReady(ids.Guard_Talent.WildCharge, timeShift);
	local pulv 												= ConRO:AbilityReady(ids.Guard_Talent.Pulverize, timeShift);
		local pulvBuff 											= ConRO:Aura(ids.Guard_Buff.PulverizeBuff, timeShift + 3);

	local _AdaptiveSwarm_RDY								= ConRO:AbilityReady(ids.Covenant_Ability.AdaptiveSwarm, timeShift);
		local _AdaptiveSwarm_DEBUFF								= ConRO:TargetAura(ids.Covenant_Debuff.AdaptiveSwarm, timeShift);
	local _ConvoketheSpirits_RDY							= ConRO:AbilityReady(ids.Covenant_Ability.ConvoketheSpirits, timeShift);
	local _KindredSpirits_RDY								= ConRO:AbilityReady(ids.Covenant_Ability.KindredSpirits, timeShift);
		local _EmpowerBond_RDY								= ConRO:AbilityReady(ids.Covenant_Ability.EmpowerBond, timeShift);
		local _KindredEmpowerment_BUFF							= ConRO:Aura(ids.Covenant_Buff.KindredEmpowerment, timeShift);
		local _KindredSpirits_BUFF								= ConRO:Aura(ids.Covenant_Buff.KindredSpirits, timeShift);
		local _LoneEmpowerment_RDY								= ConRO:AbilityReady(ids.Covenant_Ability.LoneEmpowerment, timeShift);
		local _LoneEmpowerment_BUFF								= ConRO:Aura(ids.Covenant_Buff.LoneEmpowerment, timeShift);
		local _LoneSpirit_BUFF									= ConRO:Aura(ids.Covenant_Buff.LoneSpirit, timeShift);	
	local _RavenousFrenzy_RDY								= ConRO:AbilityReady(ids.Covenant_Ability.RavenousFrenzy, timeShift);
	
--Conditions	
	local inRange 											= ConRO:IsSpellInRange(GetSpellInfo(ids.Guard_Talent.WildCharge_Bear), 'target');
	local incombat 											= UnitAffectingCombat('player');
	local tarInMelee										= ConRO:Targets(ids.Guard_Ability.Mangle);
	
--Indicators	
	ConRO:AbilityInterrupt(ids.Guard_Ability.SkullBash, sbash and ConRO:Interrupt());
	ConRO:AbilityPurge(ids.Guard_Ability.Soothe, soothe and ConRO:Purgable());
	
	ConRO:AbilityTaunt(ids.Guard_Ability.Growl, growl);

	ConRO:AbilityBurst(ids.Covenant_Ability.ConvoketheSpirits, _ConvoketheSpirits_RDY and ConRO_BurstButton:IsVisible());
	ConRO:AbilityBurst(ids.Covenant_Ability.RavenousFrenzy, _RavenousFrenzy_RDY and ConRO_BurstButton:IsVisible());
	
--Rotations	
	if bearform and not bf then
		return ids.Guard_Ability.BearForm;
	end

	if _KindredSpirits_RDY and not _LoneSpirit_BUFF and not _KindredSpirits_BUFF then
		return ids.Covenant_Ability.KindredSpirits;
	end
	
	if inRange and wildG then
		return ids.Guard_Talent.WildCharge_Bear;
	end
	
	if mfire and not mfDebuff then
		return ids.Guard_Ability.Moonfire;
	end

	if thr and thrCD <= 0 and thrCount < 3 then
		return ids.Guard_Ability.Thrash_Bear;
	end

	if pulv and not pulvBuff and thrCount >= 3 then
		return ids.Guard_Talent.Pulverize;
	end
	
	if thr and thrCD <= 0 then
		return ids.Guard_Ability.Thrash_Bear;
	end	
	
	if mang then
		return ids.Guard_Ability.Mangle;
	end
	
	if mfire and ggBuff then
		return ids.Guard_Ability.Moonfire;
	end

	if _AdaptiveSwarm_RDY and not _AdaptiveSwarm_DEBUFF then
		return ids.Covenant_Ability.AdaptiveSwarm;
	end	

	if _ConvoketheSpirits_RDY and ConRO_FullButton:IsVisible() then
		return ids.Covenant_Ability.ConvoketheSpirits;
	end

	if _EmpowerBond_RDY and _KindredSpirits_BUFF then
		return ids.Covenant_Ability.EmpowerBond;
	end

	if _LoneEmpowerment_RDY and _LoneSpirit_BUFF then
		return ids.Covenant_Ability.LoneEmpowerment;
	end

	if _RavenousFrenzy_RDY and ConRO_FullButton:IsVisible() then
		return ids.Covenant_Ability.RavenousFrenzy;
	end

	if maul and not ConRO:TarYou() and rage >= 90 then
		return ids.Guard_Ability.Maul;
	end	
	
	if swipe then
		return ids.Guard_Ability.Swipe_Bear;
	end
return nil;
end

function ConRO.Druid.GuardianDef(_, timeShift, currentSpell, gcd, tChosen, pvpChosen)
--Resources
	local rage 												= UnitPower('player', Enum.PowerType.Rage);
	local rageMax 											= UnitPowerMax('player', Enum.PowerType.Rage);	

--Abilities	
	local surv 												= ConRO:AbilityReady(ids.Guard_Ability.SurvivalInstincts, timeShift);
	local bark 												= ConRO:AbilityReady(ids.Guard_Ability.Barkskin, timeShift);
		local _BarkskinBUFF										= ConRO:Aura(ids.Guard_Buff.Barkskin, timeShift);
	local iron 												= ConRO:AbilityReady(ids.Guard_Ability.Ironfur, timeShift);
	local fregen 											= ConRO:AbilityReady(ids.Guard_Ability.FrenziedRegeneration, timeShift);
	local _BerserkRDY										= ConRO:AbilityReady(ids.Guard_Ability.Berserk, timeShift);

	local _BristlingFurRDY									= ConRO:AbilityReady(ids.Guard_Talent.BristlingFur, timeShift);
	local _IncarnationGuardianofUrsocRDY					= ConRO:AbilityReady(ids.Guard_Talent.IncarnationGuardianofUrsoc, timeShift);
		local _IncarnationGuardianofUrsocBUFF					= ConRO:Aura(ids.Guard_Buff.IncarnationGuardianofUrsoc, timeShift);
		
	local ironBuff, ifBCount								= ConRO:Aura(ids.Guard_Buff.Ironfur, timeShift);

	local _Fleshcraft_RDY									= ConRO:AbilityReady(ids.Covenant_Ability.Fleshcraft, timeShift);
	
--Conditions	
	local playerPh 											= ConRO:PercentHealth('player');
	local incombat 											= UnitAffectingCombat('player');
	
--Rotations	
	if fregen and playerPh <= 60 then
		return ids.Guard_Ability.FrenziedRegeneration;
	end

	if _Fleshcraft_RDY and not incombat then
		return ids.Covenant_Ability.Fleshcraft;
	end
	
	if _BristlingFurRDY and ConRO:TarYou() then
		return ids.Guard_Talent.BristlingFur;
	end
	
	if iron and ConRO:TarYou() and ifBCount < 4 then
		return ids.Guard_Ability.Ironfur;
	end
	
	if bark and not _IncarnationGuardianofUrsocBUFF and not _SurvivalInstinctsBUFF then
		return ids.Guard_Ability.Barkskin;
	end
	
	if tChosen[ids.Guard_Talent.IncarnationGuardianofUrsoc] then
		if _IncarnationGuardianofUrsocRDY and not _BarkskinBUFF and not _SurvivalInstinctsBUFF then
			return ids.Guard_Talent.IncarnationGuardianofUrsoc;
		end
	else
		if _BerserkRDY then
			return ids.Guard_Ability.Berserk;
		end
	end
	
	if surv and not _BarkskinBUFF and not _IncarnationGuardianofUrsocBUFF then
		return ids.Guard_Ability.SurvivalInstincts;
	end	

	if _Fleshcraft_RDY then
		return ids.Covenant_Ability.Fleshcraft;
	end
	
return nil;
end

function ConRO.Druid.Restoration(_, timeShift, currentSpell, gcd, tChosen, pvpChosen)
--Abilities
	local soothe											= ConRO:AbilityReady(ids.Resto_Ability.Soothe, timeShift); 
	local tranq 											= ConRO:AbilityReady(ids.Resto_Ability.Tranquility, timeShift);
	local lbloom 											= ConRO:AbilityReady(ids.Resto_Ability.Lifebloom, timeShift);
	local regrow 											= ConRO:AbilityReady(ids.Resto_Ability.Regrowth, timeShift);

	local _AdaptiveSwarm_RDY								= ConRO:AbilityReady(ids.Covenant_Ability.AdaptiveSwarm, timeShift);
		local _AdaptiveSwarm_DEBUFF								= ConRO:TargetAura(ids.Covenant_Debuff.AdaptiveSwarm, timeShift);
	local _ConvoketheSpirits_RDY							= ConRO:AbilityReady(ids.Covenant_Ability.ConvoketheSpirits, timeShift);
	local _KindredSpirits_RDY								= ConRO:AbilityReady(ids.Covenant_Ability.KindredSpirits, timeShift);
		local _EmpowerBond_RDY								= ConRO:AbilityReady(ids.Covenant_Ability.EmpowerBond, timeShift);
		local _KindredEmpowerment_BUFF							= ConRO:Aura(ids.Covenant_Buff.KindredEmpowerment, timeShift);
		local _KindredSpirits_BUFF								= ConRO:Aura(ids.Covenant_Buff.KindredSpirits, timeShift);
		local _LoneEmpowerment_RDY								= ConRO:AbilityReady(ids.Covenant_Ability.LoneEmpowerment, timeShift);
		local _LoneEmpowerment_BUFF								= ConRO:Aura(ids.Covenant_Buff.LoneEmpowerment, timeShift);
		local _LoneSpirit_BUFF									= ConRO:Aura(ids.Covenant_Buff.LoneSpirit, timeShift);	
	local _RavenousFrenzy_RDY								= ConRO:AbilityReady(ids.Covenant_Ability.RavenousFrenzy, timeShift);

--Conditions	
--Indicators	
	ConRO:AbilityPurge(ids.Resto_Ability.Soothe, soothe and ConRO:Purgable());
	
	ConRO:AbilityBurst(ids.Resto_Ability.Tranquility, tranq);

	ConRO:AbilityRaidBuffs(ids.Resto_Ability.Lifebloom, lbloom and not ConRO:OneBuff(ids.Resto_Buff.Lifebloom));

--Rotations
	if _KindredSpirits_RDY and not _LoneSpirit_BUFF and not _KindredSpirits_BUFF then
		return ids.Covenant_Ability.KindredSpirits;
	end
	
	return nil;
end

function ConRO.Druid.RestorationDef(_, timeShift, currentSpell, gcd, tChosen, pvpChosen)
--Abilities
	local bark 												= ConRO:AbilityReady(ids.Resto_Ability.Barkskin, timeShift);
	
	local renewal 											= ConRO:AbilityReady(ids.Resto_Talent.Renewal, timeShift);

	local _Fleshcraft_RDY									= ConRO:AbilityReady(ids.Covenant_Ability.Fleshcraft, timeShift);
	
--Conditions	
	local playerPh 											= ConRO:PercentHealth('player');

--Rotations	
	if renewal and playerPh <= 60 then
		return ids.Resto_Talent.Renewal;
	end

	if _Fleshcraft_RDY then
		return ids.Covenant_Ability.Fleshcraft;
	end
	
	if bark then
		return ids.Resto_Ability.Barkskin;
	end
		
	return nil;
end
